/*
  Fichier en-tete contenant les declarations des
  fonctions liees aux tableaux.
*/


#ifndef _TABLEAU_HPP_
#define _TABLEAU_HPP_
/*
  Les deux lignes precedentes permettent de s'assurer que le fichier
  en-tete n'a pas ete inclus plusieurs fois. Si le fichier etait inclus
  plusieurs fois, la meme fonction aurait plusieurs declaration ce qui
  causerait une erreur.

  Ci dessus, on peut remplacer "_TABLEAU_HPP_" par n'importe quelle
  chaine de caractere suffisament particuliere pour ne pas etre utilisee
  ailleurs.
*/

#include <cmath>
#include "alea.hpp"

//Remplit le tableau tab (de taille n) avec des nombres aleatoires
void remplit_tableau(double *tab, int n);


// Renvoie le maximum du tableau tab de taille n
double maximum(double *tab, int n);

// Renvoie la position du maximum en valeur absolue du tableau tab de taille n
double i_maximum_abs(double *tab, int n);


/* Algorithmes de tri*/
// Tri par insertion
void tri_insertion(double *tableau, int taille);

// Tri rapide (avec une fonction auxilliaire)
void tri_rapide(double *tableau, int taille);
void tri_rapide_aux(double *tableau, int debut, int fin);


#endif /* _TABLEAU_HPP_ */
