#include "complexe.hpp"



std::ostream & operator<<(std::ostream& o, complexe const &z)
{
  /*
	Affichage "joli" d'un nombre complexe. On aurait pu ecrire
	un affichage plus rudimentaire avec
	o << z.x << " + "<< z.y << " i "
  */
  if (z.x == 0 && z.y == 0)
	o << 0;
  
  if (z.x != 0)
	o << z.x;
  
  if (z.x!=0 && z.y>0)
	{
	  if (z.y==1)
		o << " + i";
	  else
		o << " + " << z.y << " i";
	}

  if (z.x==0 && z.y>0)
	{
	  if (z.y==1)
		o << "i";
	  else
		o << z.y << " i";
	}

  if (z.y<0)
	{
	  if (z.y==-1)
		o << " - i";
	  else
		o << " - " << -z.y << " i";
	}
  
  return o;
}



complexe operator+(complexe const &z1, complexe const &z2)
{
  return complexe( z1.x+z2.x , z1.y+z2.y );
}

complexe operator-(complexe const &z1, complexe const &z2)
{
  return z1 + (-z2);
}

complexe operator*(complexe const &z1, complexe const &z2)
{
  return complexe( z1.x*z2.x - z1.y*z2.y , z1.x*z2.y + z1.y*z2.x  );
}

complexe operator/(complexe const &z1, complexe const &z2)
{
  // Le carre du module de z2
  double nz2 = z2.x*z2.x + z2.y*z2.y;

  // inv_z2 correspond a 1/z2 (noter que 1/(a+ib) = (a-ib)/(a^2+b^2) )
  complexe inv_z2 = complexe(z2.x/nz2, -z2.y/nz2);

  return z1*inv_z2;
}


/*
  Contrairement aux cinq fonctions precedentes, les quatre fonctions suivantes sont
  des methodes (c'est a dire des membre qui sont aussi des fonction) de la classe
  complexe. On doit donc le signaler au compilateur a l'aide de la syntaxe
  "complexe::".
  Hors de la declaration de la classe, ecrire "ma_classe::f" signifie que l'on
  defini la methode "f", membre de la classe "ma_classe".
  
*/


complexe &complexe::operator+=(complexe const &z)
{
  *this = *this + z;
  return *this;
}

complexe &complexe::operator*=(complexe const &z)
{
  *this = *this * z;
  return *this;
}

complexe &complexe::operator-=(complexe const &z)
{
  *this = *this - z;
  return *this;
}

complexe &complexe::operator/=(complexe const &z)
{
  *this = *this / z;
  return *this;
}

