#include "alea.hpp"
#include <iostream>
#include <cmath>



/*
  Une classe correspondant aux variables gaussiennes de moyenne mu et de variance sigma2.
*/
class gauss : public va_reelle
{
private:
  double mu;
  double sigma2;
public:
  gauss(double mu_ = 0, double sigma2_ = 1) : mu(mu_), sigma2(sigma2_) {};
  // Un constructeur (par defaut, il s'agit de la loi normale centree reduite).
  
  double operator() (void) const
  {
	return mu + sqrt(-2*sigma2*log(unif01())) * cos(2*M_PI*unif01());
	// Simulation par la methode Box-Muller.
  }

  double moy(void) const
  {return mu;}
  
  double var(void) const
  {return sigma2;}
  
};



int main(void)
{
  gauss G(2); // Une variable de loi normale centree en 2 de variance 1

  int n = 10000;
  
  std::cout << "G suit la loi normale de moyenne " << G.moy() << " et de variance " << G.var() << "\n";
  std::cout << "Par methode de Monte Carlo avec " << n << " tirages, on trouve :\n";
  std::cout << "moyenne de G  : " << G.E(n) << std::endl;
  std::cout << "variance de G : " << G.V(n) << std::endl;
  
  return 0;
}
